/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Offline教材 オフラインログのcourseタグデータ保持クラス
//			変更履歴
//				2004.01.08	新規作成	二條　智文
//
package jp.co.ntt.lms.lo.Offline.OfflineLog;

import org.w3c.dom.*;
import java.util.*;

/**
 * Offline教材 オフラインログのcourseタグデータ保持クラス<BR>
 * オフラインログのcourseノードを受け取り、自身の内部変数にデータを
 * 格納します。
 */
public class OfflineCourse implements OfflineLogConst {

	// 自身のノードオブジェクトを保持します。
	private Element mobjCourseElm = null;

	// エラーメッセージ
	private static final String ERR_PRE = "<course>:";
	private static final String ERR_NOT_COURSE = ERR_PRE + "courseタグではありません。";
	private static final String ERR_NOEXIST_SYS = ERR_PRE + "sysタグが存在しません。";
	private static final String ERR_NOEXIST_SID = ERR_PRE + "sid属性が存在しません。";
	private static final String ERR_NOEXIST_ORG = ERR_PRE + "orgタグが存在しません。";
	private static final String ERR_INVALID_TT = ERR_PRE + "tt属性が不正です。";
	private static final String ERR_INVALID_SD = ERR_PRE + "sd属性が不正です。";
	private static final String ERR_INVALID_ED = ERR_PRE + "ed属性が不正です。";
	private static final String ERR_INVALID_STATUS = ERR_PRE + "status属性が不正です。";

	// 属性保持
	// <sys>-[sid]属性値を保持します
	private String mstrSID;

	// <org>-[tt]属性値を保持します
	private String mstrTT;
	private long mlngTT;

	// <org>-[sd]属性値を保持します
	private String mstrSD;
	private Date mdatSD;

	// <org>-[ed]属性値を保持します
	private String mstrED;
	private Date mdatED;

	// <org>-[status]属性値を保持します
	private String mstrStatus;
	private char mchrStatus;

	// sesエレメントデータを保持します。
	private Vector mvecSes = new Vector();

	/**
	 * コンストラクタです。
	 * @param objNode courseエレメントオブジェクト
	 * @exception OfflineLogParseException パースエラー
	 */
	OfflineCourse( Element objElement )
		throws OfflineLogParseException
	{
		// タグ名のチェック(course以外はエラーとする)
		String strTagName = objElement.getTagName();
		if( strTagName == null || !strTagName.equals( COURSE_ELM ) ) {
			throw new OfflineLogParseException( ERR_NOT_COURSE );
		}

		mobjCourseElm = objElement;

		parse();
	}

	/**
	 * <course>-<sys>-[sid]属性値を取得します。
	 * @return String <sys>-[sid] 属性値
	 */
	public String getSID() {
		return mstrSID;
	}

	/**
	 * <course>-<org>-[tt]属性値を取得します。
	 * @return String <course>-<org>-[tt] 属性値
	 */
	public String getTT() {
		return mstrTT;
	}

	/**
	 * <course>-<org>-[tt]属性値をlong型のミリ秒に変換した値を取得します。
	 * @return long <course>-<org>-[tt]属性値をlong型のミリ秒に変換した値
	 */
	public long getTTLong() {
		return mlngTT;
	}

	/**
	 * <course>-<org>-[sd] 属性値を取得します。
	 * @return String <course>-<org>-[sd] 属性値
	 */
	public String getSD() {
		return mstrSD;
	}

	/**
	 * <course>-<org>-[sd] 属性値を日付データに変換した値を取得します。
	 * @return Date <course>-<org>-[sd] 属性値を日付データに変換した値
	 */
	public Date getSDDate() {
		return mdatSD;
	}

	/**
	 * <course>-<org>[ed] 属性値を取得します。
	 * @return String <course>-<org>[ed] 属性値
	 */
	public String getED() {
		return mstrED;
	}

	/**
	 * <course>-<org>-[ed] 属性値を日付データに変換した値を取得します。
	 * @return Date <course>-<org>-[ed] 属性値を日付データに変換した値
	 */
	public Date getEDDate() {
		return mdatED;
	}

	/**
	 * <course>-<org>-[status] 属性値を取得します。
	 * @return String <course>-<org>-[status] 属性値
	 */
	public String getStatus() {
		return mstrStatus;
	}

	/**
	 * <course>-<org>-[status] 属性値をcharに変換した値を取得します。
	 * @return char <course>-<org>-[status] 属性値をcharに変換した値
	 */
	public char getStatusChar() {
		return mchrStatus;
	}

	/**
	 * 保持しているsesエレメントデータの長さを取得します。
	 * @return int
	 */
	public int getSesLength() {
		return mvecSes.size();
	}

	/**
	 * 指定されたインデックスのsesエレメントデータを取得します。
	 * @return OfflineCourseSes
	 */
	public OfflineCourseSes getSes( int index ) {
		return (OfflineCourseSes)mvecSes.get(index);
	}

	/**
	 * 学習回数を指定して、Course-sesエレメントデータを取得します。
	 * 該当学習回のCourse-sesエレメントが存在しない場合はnullを返します。
	 * @param intMCNT 学習回数
	 * @return OfflineCourseSes
	 */
	public OfflineCourseSes getSesFromMcnt( int intMCNT ) {

		OfflineCourseSes objSes = null;

		for( int i = 0; i < mvecSes.size(); i++ ) {

			objSes = (OfflineCourseSes)mvecSes.get(i);

			if( objSes.getMCNT() == intMCNT ) {
				return objSes;
			}
		}

		return null;
	}

	/**
	 * Course-ses内で最大の学習回数を取得する
	 * 取得できない場合は-1を返す
	 * @return int 最大の学習回数
	 */
	public int getMaxMcnt() {

		int intMax = -1;

		for( int i = 0; i < mvecSes.size(); i++ ) {

			OfflineCourseSes objSes = (OfflineCourseSes)mvecSes.get(i);

			int intTemp = objSes.getMCNT();

			intMax = (intTemp > intMax? intTemp : intMax);
		}

		return intMax;
	}

//------------------------------------ 内部関数 --------------------------------
	/**
	 * コンストラクタで受け取ったエレメントないのデータを
	 * 取得して、自身の変数に格納します。
	 */
	private void parse()
		throws OfflineLogParseException
	{
		// <course>-<sys>エレメントを取得する
		NodeList objSysList = mobjCourseElm.getElementsByTagName( COURSE_SYS_ELM );

		int intSysLength = objSysList.getLength();

		if( intSysLength == 0 ) {
			// <course>-<sys>エレメントが存在しない場合は、エラーとする。
			throw new OfflineLogParseException( ERR_NOEXIST_SYS );
		}

		Element objSysElm = (Element)objSysList.item( 0 );

		// <sys>-[sid]属性値を設定する
		mstrSID = objSysElm.getAttribute(COURSE_SYS_SID_ATTR);
		if( mstrSID.equals( "" ) ) {
			// 存在しない場合はNULLとする
			mstrSID = null;
		}

		// <course>-<org>エレメントを取得する
		NodeList objOrgList = mobjCourseElm.getElementsByTagName( COURSE_ORG_ELM );

		int intOrgLength = objOrgList.getLength();

		if( intOrgLength == 0 ) {
			// <course>-<sys>エレメントが存在しない場合は、エラーとする。
			throw new OfflineLogParseException( ERR_NOEXIST_ORG );
		}

		Element objOrgElm = (Element)objOrgList.item( 0 );

		// <org>-[tt]属性値を設定する
		mstrTT = objOrgElm.getAttribute( COURSE_ORG_TT_ELM );
		try {
			mlngTT = OfflineUtil.parseTime( mstrTT );
		}
		catch( OfflineLogFormatException fe ) {
			// 属性値が不正の場合はNULLとし、long値は-1とする
			mstrTT = null;
			mlngTT = -1;
		}

		// <org>-[sd]属性値を設定する
		mstrSD = objOrgElm.getAttribute( COURSE_ORG_SD_ELM );
		try {
			mdatSD = OfflineUtil.parseDate( mstrSD );
		}
		catch( OfflineLogFormatException fe ) {
			// 属性値が不正の場合はNULLとし、date値はnullとする
			mstrSD = null;
			mdatSD = null;
		}

		// <org>-[ed]属性値を設定する
		mstrED = objOrgElm.getAttribute( COURSE_ORG_ED_ELM );
		try {
			mdatED = OfflineUtil.parseDate( mstrED );
		}
		catch( OfflineLogFormatException fe ) {
			// 属性値が不正の場合はNULLとし、date値はnullとする
			mstrED = null;
			mdatED = null;
		}

		// <org>-[status]属性値を設定する
		mstrStatus = objOrgElm.getAttribute( COURSE_ORG_STATUS_ELM );
		try {
			mchrStatus = OfflineUtil.parseStatus( mstrStatus );
		}
		catch( OfflineLogFormatException fe ) {
			// 属性値が不正の場合はNULLとし、char値は 0 (null文字)とする
			mstrStatus = null;
			mchrStatus = 0;
		}

		// <course>-<org>-<ses> エレメントの設定
		NodeList objSesList = objOrgElm.getElementsByTagName( COURSE_SES_ELM );

		Element objSesElm = null;
		for ( int i=0; i<objSesList.getLength(); i++ ){
			objSesElm = (Element)objSesList.item(i);

			// Itemエレメントリスト用のVectorに追加する。
			mvecSes.add( new OfflineCourseSes( objSesElm ) );
		}

	}
//------------------------------------ 内部関数 --------------------------------
}

